* WINTH.PRG

* Test program puts a few windows on the screen and calls
*  the thermometer from within each window, without disturbing
*  the output to that window.
*
* The thermometer can also be toggled with the space bar
*  without any special checking by the calling program.

set talk off

* define the output windows
define window win1 from  1, 3 to  6,33 title [Window 1];
 color scheme 8 shadow
define window win2 from  1,38 to  6,68 title [Window 2];
 color scheme 8 shadow
define window win3 from 17,25 to 22,55 title [Window 3];
 color scheme 8 shadow

runlen = 10   && how many times to go through the whole loop
eachlen = 5   && how many times to display to each window

* thermometer message
th_mess = [Hit <SPACE> to toggle thermometer, <END> to cancel]

* logical determines if we cancelled early
alldone = .f. 

* initialize thermometer
do thermo with runlen * eachlen * 4

* set up the toggle key
on key label SPACEBAR do thtoggle

* END key to cancel
on key label END do alldone

* counter to store number of iterations completed
done = 0

for i = 1 to runlen

  * a little to the first window
  activate window win1
  for j = 1 to eachlen
    done = done + 1
    do thermo with [Window 1], th_mess, done
    ? [Window 1 - ], done
  endfor
  
  * a little to the second window
  activate window win2
  for j = 1 to eachlen
    done = done + 1
    do thermo with [Window 2], th_mess, done
    ? [Window 2 - ], done
  endfor
  
  * a little to the third window
  activate window win3
  for j = 1 to eachlen
    done = done + 1
    do thermo with [Window 3], th_mess, done
    ? [Window 3 - ], done
  endfor
  
  * and a little to the screen
  activate screen
  for j = 1 to eachlen
    done = done + 1
    do thermo with [Screen], th_mess, done
    ? [Screen - ], done
  endfor
  
endfor

* we got all the way through
alldone = .t.

* shut down procedure
do alldone
return


procedure alldone

* reset the OKLs
on key label END
on key label SPACEBAR

* shut down the thermometer
do thermo

* lose the windows
release windows win1, win2, win3

* if we cancelled early, display the cancel message
if !alldone
  cancel
endif
